One data grid for JavaScript, React, Vue & Angular. Sorting, filtering, virtualization, pinning, and CSV export included. Early access $199 $349 → [Get it now]

How to profile Vue performance

Profiling Vue application performance identifies rendering bottlenecks, slow components, and unnecessary re-renders for targeted optimization. As the creator of CoreUI, I’ve profiled and optimized numerous production Vue applications. Vue DevTools combined with browser Performance API provides detailed insights into component render times, lifecycle hooks, and reactive updates. This approach reveals performance issues enabling data-driven optimization decisions for faster user experiences.

Use Vue DevTools Performance tab, browser Performance API, and custom timing to profile component rendering and identify bottlenecks.

Vue DevTools performance profiling:

<script setup>
// Enable performance tracking in main.js
// main.js
import { createApp } from 'vue'
import App from './App.vue'

const app = createApp(App)

if (import.meta.env.MODE === 'development') {
  app.config.performance = true // Enable Vue DevTools performance tracking
}

app.mount('#app')
</script>

Custom performance composable:

// usePerformance.js
import { onMounted, onUpdated, onUnmounted } from 'vue'

export function usePerformance(componentName) {
  const marks = {
    mountStart: `${componentName}-mount-start`,
    mountEnd: `${componentName}-mount-end`,
    updateStart: `${componentName}-update-start`,
    updateEnd: `${componentName}-update-end`
  }

  // Track mount time
  performance.mark(marks.mountStart)

  onMounted(() => {
    performance.mark(marks.mountEnd)
    performance.measure(
      `${componentName} mount`,
      marks.mountStart,
      marks.mountEnd
    )

    const measure = performance.getEntriesByName(`${componentName} mount`)[0]
    console.log(`${componentName} mounted in ${measure.duration.toFixed(2)}ms`)

    if (measure.duration > 100) {
      console.warn(`${componentName} mount time exceeds 100ms`)
    }
  })

  // Track updates
  let updateCount = 0
  onUpdated(() => {
    updateCount++
    performance.mark(`${marks.updateEnd}-${updateCount}`)

    if (updateCount > 1) {
      performance.measure(
        `${componentName} update ${updateCount}`,
        `${marks.updateEnd}-${updateCount - 1}`,
        `${marks.updateEnd}-${updateCount}`
      )

      const measure = performance.getEntriesByName(
        `${componentName} update ${updateCount}`
      )[0]
      console.log(`${componentName} update #${updateCount}: ${measure.duration.toFixed(2)}ms`)
    }
  })

  onUnmounted(() => {
    console.log(`${componentName} total updates: ${updateCount}`)
    performance.clearMarks()
    performance.clearMeasures()
  })
}

// Usage
import { usePerformance } from './usePerformance'

usePerformance('UserList')

Component render profiling:

<script setup>
import { ref, computed, watch } from 'vue'
import { usePerformance } from './usePerformance'

const items = ref([])
const filter = ref('')

usePerformance('FilteredList')

// Profile computed properties
const filteredItems = computed(() => {
  const start = performance.now()
  const result = items.value.filter(item =>
    item.name.toLowerCase().includes(filter.value.toLowerCase())
  )
  const duration = performance.now() - start

  if (duration > 10) {
    console.warn(`filteredItems computed took ${duration.toFixed(2)}ms`)
  }

  return result
})

// Profile watchers
watch(filter, (newValue) => {
  console.log('Filter changed, will trigger re-render')
}, { flush: 'post' }) // Run after component updates
</script>

<template>
  <div>
    <input v-model="filter" placeholder="Search..." />
    <div v-for="item in filteredItems" :key="item.id">
      {{ item.name }}
    </div>
  </div>
</template>

Render count tracking:

<script setup>
import { ref, watchEffect } from 'vue'

const renderCount = ref(0)
const data = ref({ count: 0 })

watchEffect(() => {
  renderCount.value++
  console.log(`Component rendered ${renderCount.value} times`)
  console.log('Triggered by:', data.value)
})

// Check for excessive renders
if (import.meta.env.MODE === 'development') {
  watchEffect(() => {
    if (renderCount.value > 100) {
      console.error('Component has rendered 100+ times - possible performance issue')
    }
  })
}
</script>

<template>
  <div>
    <p>Render count: {{ renderCount }}</p>
    <button @click="data.count++">Increment</button>
  </div>
</template>

Profiling large lists:

<script setup>
import { ref, onMounted } from 'vue'

const items = ref([])

onMounted(async () => {
  // Profile data loading
  performance.mark('data-load-start')

  const response = await fetch('/api/items')
  const data = await response.json()

  performance.mark('data-load-end')
  performance.measure('data-load', 'data-load-start', 'data-load-end')

  // Profile array processing
  performance.mark('process-start')
  items.value = data.map(item => ({
    ...item,
    processed: true
  }))
  performance.mark('process-end')
  performance.measure('process', 'process-start', 'process-end')

  // Profile initial render
  await new Promise(resolve => setTimeout(resolve, 0))
  performance.mark('render-complete')
  performance.measure('initial-render', 'data-load-start', 'render-complete')

  // Log results
  const measures = performance.getEntriesByType('measure')
  measures.forEach(measure => {
    console.log(`${measure.name}: ${measure.duration.toFixed(2)}ms`)
  })
})
</script>

<template>
  <div>
    <div v-for="item in items" :key="item.id">
      {{ item.name }}
    </div>
  </div>
</template>

Memory profiling:

<script setup>
import { ref, onMounted, onUnmounted } from 'vue'

const data = ref([])
let initialMemory = 0

onMounted(() => {
  if (performance.memory) {
    initialMemory = performance.memory.usedJSHeapSize
    console.log('Initial memory:', (initialMemory / 1048576).toFixed(2), 'MB')
  }

  // Load data
  data.value = Array.from({ length: 10000 }, (_, i) => ({
    id: i,
    name: `Item ${i}`,
    data: new Array(100).fill('data')
  }))

  if (performance.memory) {
    const currentMemory = performance.memory.usedJSHeapSize
    const memoryIncrease = currentMemory - initialMemory
    console.log('Memory increase:', (memoryIncrease / 1048576).toFixed(2), 'MB')
  }
})

onUnmounted(() => {
  if (performance.memory) {
    const finalMemory = performance.memory.usedJSHeapSize
    console.log('Final memory:', (finalMemory / 1048576).toFixed(2), 'MB')
    console.log('Memory cleanup:', ((initialMemory - finalMemory) / 1048576).toFixed(2), 'MB')
  }
})
</script>

FPS monitoring:

<script setup>
import { ref, onMounted, onUnmounted } from 'vue'

const fps = ref(0)
let frameCount = 0
let lastTime = performance.now()
let animationId

function measureFPS() {
  frameCount++
  const currentTime = performance.now()
  const elapsed = currentTime - lastTime

  if (elapsed >= 1000) {
    fps.value = Math.round((frameCount * 1000) / elapsed)

    if (fps.value < 30) {
      console.warn(`Low FPS detected: ${fps.value}`)
    }

    frameCount = 0
    lastTime = currentTime
  }

  animationId = requestAnimationFrame(measureFPS)
}

onMounted(() => {
  measureFPS()
})

onUnmounted(() => {
  cancelAnimationFrame(animationId)
})
</script>

<template>
  <div class="fps-counter">
    FPS: {{ fps }}
  </div>
</template>

Performance observer:

// performanceObserver.js
export function setupPerformanceObserver() {
  if (!window.PerformanceObserver) return

  const observer = new PerformanceObserver((list) => {
    for (const entry of list.getEntries()) {
      if (entry.entryType === 'measure') {
        console.log(`Performance: ${entry.name} - ${entry.duration.toFixed(2)}ms`)
      }

      if (entry.entryType === 'longtask') {
        console.warn(`Long task detected: ${entry.duration.toFixed(2)}ms`)
      }
    }
  })

  observer.observe({ entryTypes: ['measure', 'longtask'] })

  return observer
}

// main.js
import { setupPerformanceObserver } from './performanceObserver'

if (import.meta.env.MODE === 'development') {
  setupPerformanceObserver()
}

Custom profiler component:

<!-- Profiler.vue -->
<script setup>
import { ref, onMounted, onUpdated, onUnmounted } from 'vue'

const props = defineProps({
  id: String,
  onRender: Function
})

const mountTime = ref(0)
const renderCount = ref(0)
const lastRenderTime = ref(0)

onMounted(() => {
  mountTime.value = performance.now()
  logProfile('mount')
})

onUpdated(() => {
  renderCount.value++
  lastRenderTime.value = performance.now()
  logProfile('update')
})

onUnmounted(() => {
  logProfile('unmount')
})

function logProfile(phase) {
  const profile = {
    id: props.id,
    phase,
    timestamp: performance.now(),
    mountTime: mountTime.value,
    renderCount: renderCount.value,
    lastRenderTime: lastRenderTime.value
  }

  console.log('Profile:', profile)
  props.onRender?.(profile)
}
</script>

<template>
  <slot />
</template>

<!-- Usage -->
<Profiler id="UserList" :onRender="handleRender">
  <UserList />
</Profiler>

Production monitoring:

// monitoring.js
export function setupProductionMonitoring() {
  if (import.meta.env.MODE !== 'production') return

  // Track route changes
  let routeChangeStart = 0
  window.addEventListener('beforeunload', () => {
    routeChangeStart = performance.now()
  })

  // Track long tasks
  if (PerformanceObserver.supportedEntryTypes?.includes('longtask')) {
    const observer = new PerformanceObserver((list) => {
      for (const entry of list.getEntries()) {
        // Send to analytics
        console.log('Long task:', entry.duration)
      }
    })
    observer.observe({ entryTypes: ['longtask'] })
  }

  // Track Core Web Vitals
  if (PerformanceObserver.supportedEntryTypes?.includes('largest-contentful-paint')) {
    const observer = new PerformanceObserver((list) => {
      const entries = list.getEntries()
      const lastEntry = entries[entries.length - 1]
      console.log('LCP:', lastEntry.renderTime || lastEntry.loadTime)
    })
    observer.observe({ entryTypes: ['largest-contentful-paint'] })
  }
}

Best Practice Note

Enable app.config.performance in development for Vue DevTools profiling. Use Performance API to measure mount and update times. Track render counts to identify unnecessary updates. Profile computed properties and watchers for slow operations. Monitor FPS for smooth animations. Use PerformanceObserver for long tasks detection. Measure memory usage for large datasets. Set performance budgets and warn when exceeded. This is how we profile CoreUI Vue applications—DevTools performance tracking, custom timing hooks, and production monitoring identifying bottlenecks and ensuring components render under 16ms for 60fps smooth experiences.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
CoreUI & Vue.js Forge… cause 1 is just not enough!
CoreUI & Vue.js Forge… cause 1 is just not enough!

Vue.js Forge
Vue.js Forge

How to create a single page application using React.js
How to create a single page application using React.js

React v18.0 – finally is of legal age?
React v18.0 – finally is of legal age?

One data grid for JavaScript, React, Vue & Angular. Sorting, filtering, virtualization, pinning, and CSV export included. Early access $199 $349 → [Get it now]

How to profile Angular performance

Profiling Angular applications identifies performance bottlenecks in rendering, change detection, and component initialization. As the creator of CoreUI, I’ve optimized numerous slow Angular applications. Chrome DevTools and Angular DevTools provide profiling capabilities to measure component render times and change detection cycles. This approach helps you identify and fix performance issues before they impact users.

Use Chrome DevTools Performance tab and Angular DevTools Profiler to identify and fix Angular performance bottlenecks.

Chrome DevTools Performance profiling:

// app.component.ts
import { Component, OnInit } from '@angular/core'

@Component({
  selector: 'app-root',
  template: `
    <div>
      <h1>Performance Test</h1>
      <app-user-list [users]="users"></app-user-list>
    </div>
  `
})
export class AppComponent implements OnInit {
  users: any[] = []

  ngOnInit() {
    // Generate large dataset
    this.users = Array.from({ length: 1000 }, (_, i) => ({
      id: i,
      name: `User ${i}`,
      email: `user${i}@example.com`
    }))
  }
}

Profile in Chrome DevTools:

  1. Open Chrome DevTools (F12)
  2. Go to Performance tab
  3. Click Record button
  4. Interact with application
  5. Stop recording
  6. Analyze flame graph:
    • Yellow: JavaScript execution
    • Purple: Rendering
    • Green: Painting
    • Look for long tasks (>50ms)

Performance measurement API:

// performance.service.ts
import { Injectable } from '@angular/core'

@Injectable({
  providedIn: 'root'
})
export class PerformanceService {
  measureComponentInit(componentName: string, callback: () => void) {
    const measureName = `${componentName}-init`

    performance.mark(`${measureName}-start`)
    callback()
    performance.mark(`${measureName}-end`)

    performance.measure(
      measureName,
      `${measureName}-start`,
      `${measureName}-end`
    )

    const measure = performance.getEntriesByName(measureName)[0]
    console.log(`${componentName} initialization: ${measure.duration.toFixed(2)}ms`)
  }

  logPerformanceMetrics() {
    const entries = performance.getEntriesByType('measure')
    console.table(entries.map(entry => ({
      name: entry.name,
      duration: `${entry.duration.toFixed(2)}ms`
    })))
  }
}

// Using in component
@Component({
  selector: 'app-user-list',
  template: '<div>...</div>'
})
export class UserListComponent implements OnInit {
  constructor(private perfService: PerformanceService) {}

  ngOnInit() {
    this.perfService.measureComponentInit('UserListComponent', () => {
      this.loadUsers()
    })
  }

  loadUsers() {
    // Expensive operation
  }
}

Angular DevTools Profiler:

// Enable profiling in production (app.module.ts)
import { ApplicationRef } from '@angular/core'
import { enableDebugTools } from '@angular/platform-browser'

export class AppModule {
  constructor(appRef: ApplicationRef) {
    const componentRef = appRef.components[0]
    enableDebugTools(componentRef)
  }
}

Steps in Angular DevTools:

  1. Install Angular DevTools extension
  2. Open DevTools → Angular tab
  3. Go to Profiler tab
  4. Click “Record” button
  5. Interact with app
  6. Stop recording
  7. View:
    • Change detection cycles
    • Component render times
    • Bar chart of slowest components

Measure change detection:

// change-detection-profiler.ts
import { ApplicationRef, NgZone } from '@angular/core'
import { Injectable } from '@angular/core'

@Injectable({
  providedIn: 'root'
})
export class ChangeDetectionProfiler {
  private detectionCount = 0

  constructor(
    private appRef: ApplicationRef,
    private zone: NgZone
  ) {
    this.monitorChangeDetection()
  }

  private monitorChangeDetection() {
    this.zone.onStable.subscribe(() => {
      this.detectionCount++
      console.log(`Change detection cycles: ${this.detectionCount}`)
    })
  }

  logChangeDetectionStats() {
    console.log(`Total change detection cycles: ${this.detectionCount}`)
  }
}

Profile specific operations:

// data.component.ts
import { Component } from '@angular/core'

@Component({
  selector: 'app-data',
  template: '<div>{{ processedData }}</div>'
})
export class DataComponent {
  processedData: string

  processData() {
    console.time('Data Processing')

    // Expensive operation
    let result = ''
    for (let i = 0; i < 100000; i++) {
      result += String(i)
    }
    this.processedData = result

    console.timeEnd('Data Processing')
  }

  betterProcessData() {
    console.time('Optimized Processing')

    const parts: string[] = []
    for (let i = 0; i < 100000; i++) {
      parts.push(String(i))
    }
    this.processedData = parts.join('')

    console.timeEnd('Optimized Processing')
  }
}

Profile ngFor performance:

// list.component.ts
import { Component } from '@angular/core'

@Component({
  selector: 'app-list',
  template: `
    <div>
      <h3>Without trackBy (slow)</h3>
      <ul>
        <li *ngFor="let item of items">
          {{ item.name }}
        </li>
      </ul>

      <h3>With trackBy (fast)</h3>
      <ul>
        <li *ngFor="let item of items; trackBy: trackById">
          {{ item.name }}
        </li>
      </ul>
    </div>
  `
})
export class ListComponent {
  items = Array.from({ length: 1000 }, (_, i) => ({
    id: i,
    name: `Item ${i}`
  }))

  trackById(index: number, item: any) {
    return item.id
  }

  updateItems() {
    console.time('Update with trackBy')
    this.items = this.items.map(item => ({ ...item }))
    console.timeEnd('Update with trackBy')
  }
}

Measure pipe performance:

// expensive.pipe.ts
import { Pipe, PipeTransform } from '@angular/core'

@Pipe({
  name: 'expensive',
  pure: true // Important for performance
})
export class ExpensivePipe implements PipeTransform {
  transform(value: string): string {
    console.time('ExpensivePipe')

    // Expensive transformation
    let result = value
    for (let i = 0; i < 1000; i++) {
      result = result.toUpperCase().toLowerCase()
    }

    console.timeEnd('ExpensivePipe')
    return result
  }
}

// Better: Pure pipe + memoization
@Pipe({
  name: 'optimized',
  pure: true
})
export class OptimizedPipe implements PipeTransform {
  private cache = new Map<string, string>()

  transform(value: string): string {
    if (this.cache.has(value)) {
      return this.cache.get(value)!
    }

    const result = value.toUpperCase()
    this.cache.set(value, result)
    return result
  }
}

Runtime performance checks:

// performance-monitor.service.ts
import { Injectable } from '@angular/core'

@Injectable({
  providedIn: 'root'
})
export class PerformanceMonitor {
  monitorLongTasks() {
    if ('PerformanceObserver' in window) {
      const observer = new PerformanceObserver((list) => {
        for (const entry of list.getEntries()) {
          if (entry.duration > 50) {
            console.warn(`Long task detected: ${entry.duration.toFixed(2)}ms`)
          }
        }
      })

      observer.observe({ entryTypes: ['longtask'] })
    }
  }

  getMemoryUsage() {
    if (performance.memory) {
      return {
        usedJSHeapSize: (performance.memory.usedJSHeapSize / 1048576).toFixed(2),
        totalJSHeapSize: (performance.memory.totalJSHeapSize / 1048576).toFixed(2),
        limit: (performance.memory.jsHeapSizeLimit / 1048576).toFixed(2)
      }
    }
    return null
  }

  measureFPS() {
    let lastTime = performance.now()
    let frames = 0

    const measure = () => {
      frames++
      const currentTime = performance.now()

      if (currentTime >= lastTime + 1000) {
        const fps = Math.round((frames * 1000) / (currentTime - lastTime))
        console.log(`FPS: ${fps}`)
        frames = 0
        lastTime = currentTime
      }

      requestAnimationFrame(measure)
    }

    requestAnimationFrame(measure)
  }
}

Bundle size analysis:

# Analyze bundle size
ng build --stats-json

# Install webpack-bundle-analyzer
npm install --save-dev webpack-bundle-analyzer

# Analyze
npx webpack-bundle-analyzer dist/your-app/stats.json

Source map explorer:

# Install source-map-explorer
npm install --save-dev source-map-explorer

# Build with source maps
ng build --source-map

# Analyze
npx source-map-explorer dist/**/*.js

Lighthouse audit:

# Install Lighthouse CLI
npm install -g lighthouse

# Run audit
lighthouse http://localhost:4200 --view

# Or use Chrome DevTools Lighthouse tab

Best Practice Note

Use Chrome DevTools Performance tab to record and analyze application behavior during user interactions. Angular DevTools Profiler shows component-specific performance metrics and change detection cycles. Use console.time and console.timeEnd for quick performance checks during development. Enable production mode to see realistic performance—development mode includes extra checks. Use trackBy with ngFor to improve list rendering performance. Profile in production build, not development—optimizations are disabled in dev mode. This is how we profile CoreUI Angular applications—identifying bottlenecks in rendering, change detection, and bundle size to deliver fast, responsive dashboards for enterprise users.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
What's new in Bootstrap 4 ?
What's new in Bootstrap 4 ?

Bootstrap 3.0.2 and 3.0.1 - right direction?

Bootstrap – unlimited responsive template?

Genius Bootstrap Admin Template
Genius Bootstrap Admin Template